using System;
using System.Configuration;
using System.IO;

public partial class DefaultCs : System.Web.UI.Page
{

  private int height;
  private int width;

  protected void Page_Load(object sender, EventArgs e)
  {
    if (Page.IsPostBack)
    {
      height = Convert.ToInt32(ConfigurationManager.AppSettings.Get("RequiredHeight"));
      width = Convert.ToInt32(ConfigurationManager.AppSettings.Get("RequiredWidth"));
    }
  }

  protected void btnUpload_Click(object sender, EventArgs e)
  {
    Page.Validate();
    if (Page.IsValid)
    {
      if (FileUpload1.HasFile)
      {
        string extension = Path.GetExtension(FileUpload1.PostedFile.FileName);
        switch (extension.ToLower())
        {
          // Only allow uploads that look like images.
          case ".jpg":
          case ".jpeg":
          case ".gif":
          case ".bmp":
            try
            {
              if (ValidateFileDimensions())
              {
                string fileName = Path.GetFileName(FileUpload1.PostedFile.FileName);
                string saveAsName = Path.Combine(Server.MapPath("~/Uploads/"), fileName);
                FileUpload1.PostedFile.SaveAs(saveAsName);
                lblSucces.Visible = true;
              }
              else
              {
                valInvalidDimensions.IsValid = false;
                valInvalidDimensions.ErrorMessage = String.Format(valInvalidDimensions.ErrorMessage, height, width);
              }
            }
            catch
            {
              // Unable to read the file dimensions. The uploaded file is probably not an image.
              valInvalidFile.IsValid = false;
            }
            break;

          default: // The uploaded file has an incorrect extension
            valInvalidFile.IsValid = false;
            break;
        }
      }
    }
  }

  /// <summary>
  /// Validates an uploaded image by looking at its dimensions.
  /// The image is considered valid when it has the height and width as specified in the web.config file.
  /// </summary>
  /// <returns>True when the uploaded image has the dimensions specified in the web.config file, and false otherwise.</returns>
  public bool ValidateFileDimensions()
  {
    using (System.Drawing.Image myImage = System.Drawing.Image.FromStream(FileUpload1.PostedFile.InputStream))
    {
      return (myImage.Height == height && myImage.Width == width);
    }
  }
}
