Imports System
Imports System.Configuration
Imports System.IO

Partial Public Class DefaultVB
  Inherits System.Web.UI.Page

  Private height As Integer
  Private width As Integer

  Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

    If Page.IsPostBack Then
      height = Convert.ToInt32(ConfigurationManager.AppSettings.Get("RequiredHeight"))
      width = Convert.ToInt32(ConfigurationManager.AppSettings.Get("RequiredWidth"))
    End If

  End Sub

  Protected Sub btnUpload_Click(ByVal sender As Object, ByVal e As EventArgs)

    Page.Validate()

    If Page.IsValid Then
      If FileUpload1.HasFile Then
        Dim extension As String = Path.GetExtension(FileUpload1.PostedFile.FileName)
        Select Case extension.ToLower()
          ' Only allow uploads that look like images.
          Case ".jpg", ".jpeg", ".gif", ".bmp"
            Try
              If ValidateFileDimensions() Then
                Dim fileName As String = Path.GetFileName(FileUpload1.PostedFile.FileName)
                Dim saveAsName As String = Path.Combine(Server.MapPath("~/Uploads/"), fileName)
                FileUpload1.PostedFile.SaveAs(saveAsName)
                lblSucces.Visible = True
              Else
                valInvalidDimensions.IsValid = False
                ' Tell the user what the required dimensions for the image are.
                valInvalidDimensions.ErrorMessage = String.Format(valInvalidDimensions.ErrorMessage, height, width)
              End If
            Catch
              ' Unable to read the file dimensions. The uploaded file is probably not an image.
              valInvalidFile.IsValid = False
            End Try
          Case Else ' The uploaded file has an incorrect extension
            valInvalidFile.IsValid = False
        End Select
      End If
    End If
  End Sub

  ''' <summary>
  ''' Validates an uploaded image by looking at its dimensions.
  ''' The image is considered valid when it has the height and width as specified in the web.config file.
  ''' </summary>
  ''' <returns>True when the uploaded image has the dimensions specified in the web.config file, and False otherwise.</returns>
  Public Function ValidateFileDimensions() As Boolean
    Using myImage As System.Drawing.Image = System.Drawing.Image.FromStream(FileUpload1.PostedFile.InputStream)
      Return (myImage.Height = height AndAlso myImage.Width = width)
    End Using
  End Function

End Class
